;********************************
;
; Encode MOV
;
;********************************

;--------------------------------------
; first parameter is in brackets []
;---------------------------------------
On_Mode_MOV1_Br PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode MOV1 []">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODV	[par1_token_size]

	mov	eax,[@@token_start]
	mov	[par1_token_start],eax
	mov	eax,[@@token_size]
	mov	[par1_token_size],eax

	;--------------------------
	;check for null [] brackets
	;--------------------------
	mov	esi,[@@token_start]
	mov	ecx,[@@token_size]
	inc	esi
	sub	ecx,2
	.IF ZERO?
		Call	Print_Error,offset sz_err_017,[@@token_start],[@@token_size]

		;dummy par1
		mov	[par1_type],PAR_TYPE_REGISTER
		mov	[par1_value],0

		mov	[parse_mode],P2_MODE_MOV2
		ret		
	.ENDIF

	;-------------------------------
	; a little preparation
	;-------------------------------
	Call	Trim_Expression,esi,ecx
	mov	[@@token_start],eax
	mov	[@@token_size],ebx

	;ODS1	<"Trimed Expression">
	;Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	;ODS	<offset sz_tmp1>
	;ODV	[@@token_size]

	;-------------------------------
	; mov [eax],???
	;-------------------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par1_type],PAR_TYPE_REG_INDIRECT
		mov	[par1_value],ebx

		mov	[parse_mode],P2_MODE_MOV2
		ret	
	.ENDIF

	;---------------------------
	; mov [label],???
	;---------------------------
	Call	Check_Label,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par1_type],PAR_TYPE_MEM_INDIRECT
		mov	[par1_value],ebx
		mov	[par1_size],eax
		mov	[parse_mode],P2_MODE_MOV2
		ret		
	.ENDIF

	;------------------------------------
	; mov [mem32],???
	;------------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par1_type],PAR_TYPE_MEM_INDIRECT
		mov	[par1_value],ebx

		mov	[parse_mode],P2_MODE_MOV2
		ret		
	.ENDIF

	;----------------------------
	; Things are NOT so simple :(
	; requires advanced ModRM
	;----------------------------
	Call	Parse_ModRM,[@@token_start],[@@token_size]
	.IF eax==-1
		.IF [pass_nr]==1
			;---------------------
			;dummy label assumed
			;---------------------
			mov	[par1_type],PAR_TYPE_MEM_INDIRECT
			mov	[par1_value],0
			mov	[parse_mode],P2_MODE_MOV2			
		.ELSE
			;--------------------------------------
			; error if still unresolved on pass 2
			;--------------------------------------
			Call	Print_Error,offset sz_err_021,[@@token_start],[@@token_size]
			mov	[par1_type],PAR_TYPE_REGISTER
			mov	[par1_value],0
			mov	[parse_mode],P2_MODE_MOV2
		.ENDIF		
	.ELSE
		mov	[par1_type],PAR_TYPE_MODRM
		mov	[par1_value],0
		mov	[parse_mode],P2_MODE_MOV2
		ret				
	.ENDIF


	mov	[parse_mode],P2_MODE_MOV2
	ret
ENDP

;====================================
; First MOV parameter
;====================================
On_Mode_MOV1 PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode MOV1">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	;ODV	[@@token_size]

	mov	eax,[@@token_start]
	mov	[par1_token_start],eax
	
	mov	eax,[@@token_size]
	mov	[par1_token_size],eax


	;-----------------------------
	; first param in house,check
	;-----------------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax==-1
		Call	Check_Value,[@@token_start],[@@token_size]
		.IF eax==-1
			Call	Check_Token,[@@token_start],[@@token_size]
			.IF eax==-1
				Call	Print_Error,offset sz_err_028,[@@token_start],[@@token_size]
			.ELSE
				mov	eax,[token_type]
				and	eax,TYPE_INTER
				.IF ZERO?
					;----------------------------
					; we accept only inter type
					;----------------------------
					Call	Print_Error,offset sz_err_031,[@@token_start],[@@token_size]
				.ELSE
					;------------------------
					; execute token method
					;------------------------
					Call	[token_method],[token_params]
				.ENDIF
				ret
			.ENDIF
		.ELSE	
			Call	Print_Error,offset sz_err_028,[@@token_start],[@@token_size]
			;------------------
			; dummy param
			;------------------
			mov	[par1_type],PAR_TYPE_REGISTER
			mov	[par1_value],0
		.ENDIF
	.ELSE
		mov	[par1_type],PAR_TYPE_REGISTER
		mov	[par1_value],ebx
		mov	[par1_size],eax		
	.ENDIF


	mov	[parse_mode],P2_MODE_MOV2
	ret
On_Mode_MOV1 ENDP



;------------------------------------
; Seccond Parameter is normal
; aka not in barckets
;------------------------------------
On_Mode_MOV2 PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode MOV2">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	;ODV	[@@token_size]

	;--------------------
	; save values
	;--------------------
	mov	eax,[@@token_start]
	mov	[par2_token_start],eax

	mov	eax,[@@token_size]
	mov	[par2_token_size],eax

	;-----------------------------
	; 2nd param in house,check
	;-----------------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax==-1
		Call	Check_Value,[@@token_start],[@@token_size]
		.IF eax==-1
			;----------------------------------------
			; check intermediate token as dword ptr
			;-----------------------------------------
			Call	Check_Token,[@@token_start],[@@token_size]
			.IF eax==-1
				Call	Print_Error,offset sz_err_028,[@@token_start],[@@token_size]
			.ELSE
				mov	eax,[token_type]
				and	eax,TYPE_INTER
				.IF ZERO?
					;----------------------------
					; we accept only inter type
					;----------------------------
					Call	Print_Error,offset sz_err_031,[@@token_start],[@@token_size]
				.ELSE
					;------------------------
					; execute token method
					;------------------------
					Call	[token_method],[token_params]
				.ENDIF				
				ret
			.ENDIF
		.ELSE	
			mov	[par2_type],PAR_TYPE_IMEDIATE
			mov	[par2_value],ebx			
		.ENDIF
	.ELSE
		mov	[par2_type],PAR_TYPE_REGISTER
		mov	[par2_value],ebx
		mov	[par2_size],eax			
	.ENDIF

	;--------------------------
	; time to encode
	; based on parameter types
	;--------------------------
	.IF [par1_type]==PAR_TYPE_REGISTER
		.IF [par2_type]==PAR_TYPE_REGISTER
			;---------------
			; mov eax,ebx
			;---------------
			Call	Encode_MOV_Reg2_Reg1,[par1_value],[par2_value]

		.ELSEIF [par2_type]==PAR_TYPE_IMEDIATE
			;-----------------
			; mov eax,1234h
			;-----------------
			Call	Encode_MOV_Reg_Imed,[par1_value],[par2_value]

		.ENDIF

	.ELSEIF [par1_type]==PAR_TYPE_REG_INDIRECT
		.IF [par2_type]==PAR_TYPE_REGISTER
			;-----------------
			; mov [esi],eax
			;-----------------
			Call	Encode_MOV_RegInd_Reg,[par1_value],[par2_value]

		.ELSEIF [par2_type]==PAR_TYPE_IMEDIATE
			;-----------------
			; mov [esi],1234h
			;-----------------
			Call	Encode_MOV_RegInd_Imed,[par1_value],[par2_value]
		.ENDIF

	.ELSEIF [par1_type]==PAR_TYPE_MEM_INDIRECT
		.IF [par2_type]==PAR_TYPE_REGISTER
			;-------------------
			; mov [1234h],eax
			;-------------------
			Call	Encode_MOV_MemInd_Reg,[par2_value],[par1_value]

		.ELSEIF [par2_type]==PAR_TYPE_IMEDIATE
			;------------------
			; mov [1234h],13
			;------------------
			Call	Encode_MOV_MemInd_Imed,[par1_value],[par2_value]
		.ENDIF

	.ELSEIF [par1_type]==PAR_TYPE_MODRM
		.IF [par2_type]==PAR_TYPE_REGISTER
			;-------------------------------
			; mov [esi+ecx*4+1234h],eax
			; opcode=89h
			;-------------------------------
			mov	ebx,089h
			Call	Encode_MOV_Reg_ModRM,[par2_value],ebx

		.ELSEIF [par2_type]==PAR_TYPE_IMEDIATE
			;-------------------------------
			; mov	[esi+4*ecx+1234h],13h
			;-------------------------------
			mov	ebx,0C7h
			CAll	Encode_MOV_ModRM_Imed,[par2_value],ebx
		.ENDIF

	.ENDIF
	


	mov	[parse_mode],P2_MODE_DEFAULT
	ret
On_Mode_MOV2 ENDP

;--------------------------------------
; seccond parameter is in brackets []
;---------------------------------------
On_Mode_MOV2_Br PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode MOV2 []">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODV	[@@token_size]

	;--------------------
	; save values
	;--------------------
	mov	eax,[@@token_start]
	mov	[par2_token_start],eax
	mov	eax,[@@token_size]
	mov	[par2_token_size],eax

	;--------------------------
	;check for null [] brackets
	;--------------------------
	mov	esi,[@@token_start]
	mov	ecx,[@@token_size]
	inc	esi
	sub	ecx,2
	.IF ZERO?
		Call	Print_Error,offset sz_err_017,[@@token_start],[@@token_size]

		;dummy par1
		mov	[par1_type],PAR_TYPE_REGISTER
		mov	[par1_value],0
		mov	[parse_mode],P2_MODE_MOV2
		ret		
	.ENDIF

	;-------------------------------
	; a little preparation
	;-------------------------------
	Call	Trim_Expression,esi,ecx
	mov	[@@token_start],eax
	mov	[@@token_size],ebx

	;ODS1	<"Trimed Expression">
	;Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	;ODS	<offset sz_tmp1>
	;ODV	[@@token_size]

	;-------------------------------
	; mov ???,[eax]
	;-------------------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par2_type],PAR_TYPE_REG_INDIRECT
		mov	[par2_value],ebx
		mov	[par2_size],eax	

		jmp	@@encode
	.ENDIF

	;---------------------------
	; mov ???,[label]
	;---------------------------
	Call	Check_Label,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par2_type],PAR_TYPE_MEM_INDIRECT
		mov	[par2_size],eax
		mov	[par2_value],ebx

		jmp	@@encode	
	.ENDIF

	;------------------------------------
	; mov ???,[mem32]
	;------------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax!=-1
		mov	[par2_type],PAR_TYPE_MEM_INDIRECT
		mov	[par2_value],ebx

		jmp	@@encode		
	.ENDIF

	;----------------------------
	; it is NOT so simple :(
	; requires advanced ModRM
	;----------------------------
	Call	Parse_ModRM,[@@token_start],[@@token_size]
	.IF eax==-1
		Call	Print_Error,offset sz_err_021,[@@token_start],[@@token_size]
		mov	[par2_type],PAR_TYPE_REGISTER
		mov	[par2_value],0

		jmp	@@encode			
	.ELSE
		mov	[par2_type],PAR_TYPE_MODRM
		mov	[par2_value],0

		jmp	@@encode				
	.ENDIF


@@encode:
	;------------------------------------
	; it's time to encode
	; mov par1,[par2]
	; based on accumulated par1,par2 types
	;------------------------------------
	.IF [par1_type]==PAR_TYPE_REGISTER
		.IF [par2_type]==PAR_TYPE_REG_INDIRECT
			;-------------------------
			; mov eax,[esi]
			;-------------------------
			Call	Encode_MOV_Reg_RegInd,[par1_value],[par2_value]

		.ELSEIF [par2_type]==PAR_TYPE_MEM_INDIRECT
			;--------------------------
			; mov eax,[1234h]
			;--------------------------
			Call	Encode_MOV_Reg_MemInd,[par1_value],[par2_value]

		.ELSEIF [par2_type]==PAR_TYPE_MODRM
			;-----------------------------------------
			; mov eax,[esi+4*ecx+1234h] 
			; opcode=8Bh
			;-----------------------------------------
			mov	ebx,08Bh
			Call	Encode_MOV_Reg_ModRM,[par1_value],ebx
		.ENDIF
	.ENDIF


	mov	[parse_mode],P2_MODE_DEFAULT
	ret
On_Mode_MOV2_Br ENDP






;==============================
; Mov eax,ebx
;==============================
Encode_MOV_Reg2_Reg1 PROC
	USES	ebx,esi,edi
	ARG	@@reg1,@@reg2:dword

	ODS1	<"+++Encode MOV Reg2 to Reg1">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode1
	; 1000101w
	;--------------------------
	mov	al,10001011b
	mov	byte ptr [edi],al
	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;----------------------
	; write opcode2
	; 11 reg1 reg2
	;----------------------
	mov	al,11000000b
	mov	ebx,[@@reg2]
	or	al,bl

	mov	ebx,[@@reg1]
	shl	ebx,3
	or	al,bl	

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	ret
ENDP

;==============================
; Mov eax,1
;==============================
Encode_MOV_Reg_Imed PROC
	USES	ebx,esi,edi
	ARG	@@register,@@imediate:dword

	ODS1	<"+++Encode MOV Reg,Imed">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode1
	; 1011 w reg
	;--------------------------


	.IF [par1_size]==32
		mov	al,10111000b
	.ELSEIF [par1_size]==16
		;-------------------------
		; emit prefix
		;-------------------------
		mov	al,066h
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1
		;--------------------
		; opcode
		;--------------------
		mov	al,10111000b

	.ELSEIF [par1_size]==08
		mov	al,10110000b

	.ENDIF


	mov	ebx,[@@register]
	or	al,bl
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;--------------------
	;write the immediate
	;--------------------
	.IF [par1_size]==32
		mov	eax,[@@imediate]
		mov	[edi],eax
		add	[out_crt],4
		add	[addr_crt],4	

	.ELSEIF [par1_size]==16
		mov	eax,[@@imediate]
		mov	word ptr [edi],ax
		add	[out_crt],2
		add	[addr_crt],2	
		
	.ELSEIF [par1_size]==08
		mov	eax,[@@imediate]
		mov	byte ptr [edi],al
		add	[out_crt],1
		add	[addr_crt],1	
	.ENDIF

	ret
ENDP

;==============================
; Mov eax,[1234h]
;==============================
Encode_MOV_Reg_MemInd PROC
	USES	ebx,esi,edi
	ARG	@@register,@@imediate:dword

	ODS1	<"+++Encode MOV Reg,[Mem]">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	.IF [@@register]==0
		;--------------------------
		; special case for EAX
		;--------------------------

		;--------------------------
		; opcode 
		; 1010 000w
		;--------------------------
		.IF [par1_size]==32
			mov	al,10100001b
		.ELSEIF [par1_size]==16
			;-------------------------
			; emit prefix
			;-------------------------
			mov	al,066h
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1
			;--------------------
			; opcode
			;--------------------
			mov	al,10100001b
		.ELSEIF [par1_size]==08
			mov	al,10100000b
		.ENDIF

		;-------------------
		; write opcode
		;-------------------
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;--------------------
		;write the immediate
		;--------------------
		mov	eax,[@@imediate]
		mov	[edi],eax

		add	[out_crt],4
		add	[addr_crt],4
	.ELSE
		;--------------------------
		; non EAX, ModRM
		; write opcode1
		; 1000 101w
		;--------------------------
		mov	al,10001011b

		.IF [par1_size]==32
			mov	al,10001011b

		.ELSEIF [par1_size]==16
			;-------------------------
			; emit prefix
			;-------------------------
			mov	al,066h
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1
			;--------------------
			; opcode
			;--------------------
			mov	al,10001011b

		.ELSEIF [par1_size]==08
			mov	al,10001010b

		.ENDIF

		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;---------------------------------
		; write ModRM
		; Mod=00 Reg=xxx R/M=101=displ32
		;---------------------------------
		mov	al,00000101b
		mov	ebx,[@@register]
		shl	ebx,3
		or	al,bl
		mov	byte ptr [edi],al

		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;--------------------
		;write the immediate
		;--------------------
		mov	eax,[@@imediate]
		mov	[edi],eax

		add	[out_crt],4
		add	[addr_crt],4
	.ENDIF	

	ret
ENDP



;==============================
; Mov [1234h],eax
;==============================
Encode_MOV_MemInd_Reg PROC
	USES	ebx,esi,edi
	ARG	@@register,@@imediate:dword

	ODS1	<"+++Encode MOV [Mem],Reg">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	.IF [@@register]==0
		;--------------------------
		; special case for EAX
		;--------------------------

		;--------------------------
		; opcode 
		; 1010 000w
		;--------------------------
		.IF [par2_size]==32
			mov	al,10100011b

		.ELSEIF [par2_size]==16
			;-------------------------
			; emit prefix
			;-------------------------
			mov	al,066h
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1
			;--------------------
			; opcode
			;--------------------
			mov	al,10100011b

		.ELSEIF [par2_size]==08
			mov	al,10100010b
		.ENDIF
		;--------------------------
		; write opcode
		;--------------------------
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;--------------------
		;write the immediate
		;--------------------
		mov	eax,[@@imediate]
		mov	[edi],eax

		add	[out_crt],4
		add	[addr_crt],4
	.ELSE
		;--------------------------
		; non EAX, ModRM
		; opcode
		; 1000 100w
		;--------------------------
		.IF [par2_size]==32
			mov	al,10001001b

		.ELSEIF [par2_size]==16
			;-------------------------
			; emit prefix
			;-------------------------
			mov	al,066h
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1
			;--------------------
			; opcode
			;--------------------
			mov	al,10001001b

		.ELSEIF [par2_size]==08
			mov	al,10001000b
		.ENDIF
	
		;------------------------
		;write opcode
		;------------------------
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;---------------------------------
		; write ModRM
		; Mod=00 Reg=xxx R/M=101=displ32
		;---------------------------------
		mov	al,00000101b
		mov	ebx,[@@register]
		shl	ebx,3
		or	al,bl
		mov	byte ptr [edi],al

		inc	edi
		add	[out_crt],1
		add	[addr_crt],1

		;--------------------
		;write the immediate
		;--------------------
		mov	eax,[@@imediate]
		mov	[edi],eax

		add	[out_crt],4
		add	[addr_crt],4
	.ENDIF	

	ret
ENDP


;==============================
; Mov [1234h],12h
;==============================
Encode_MOV_MemInd_Imed PROC
	USES	ebx,esi,edi
	ARG	@@location,@@imediate:dword

	ODS1	<"+++Encode MOV [Mem],imm">
	ODV	[@@imediate]

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; opcode1
	; 1100 011w
	;--------------------------
	.IF [flag_byte]==1
		mov	al,11000110b
	.ELSEIF [flag_word]==1
		;-------------------------
		; emit prefix
		;-------------------------
		mov	al,066h
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1
		;--------------------
		;opcode
		;--------------------
		mov	al,11000111b
	.ELSEIF [flag_dword]==1
		mov	al,11000111b
	.ELSE
		;---------------------
		; no "byte ptr"
		; so check label size
		;---------------------
		.IF [par1_size]==4
			mov	al,11000111b	

		.ELSEIF [par1_size]==2
			;-------------------------
			; emit prefix
			;-------------------------
			mov	al,066h
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1
			;------------
			; opcode
			;------------
			mov	al,11000111b

		.ELSEIF [par1_size]==1
			mov	al,11000110b
		.ELSE
			;----------------------
			;unknown, assume dword
			;----------------------
			mov	al,11000111b	
		.ENDIF
	.ENDIF


	;--------------------------
	;write opcode
	;--------------------------
	mov	byte ptr [edi],al
	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;---------------------------------
	; write ModRM
	; Mod=00 Ext=000 R/M=101=displ32
	;---------------------------------
	mov	al,00000101b
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;--------------------
	;write @@location
	;always 32bits
	;--------------------
	mov	eax,[@@location]
	mov	[edi],eax
	add	edi,4
	add	[out_crt],4
	add	[addr_crt],4


	;--------------------
	;write the immediate
	;--------------------
	mov	eax,[@@imediate]
	.IF [flag_byte]==1
		mov	byte ptr [edi],al
		add	[out_crt],1
		add	[addr_crt],1

	.ELSEIF [flag_word]==1
		mov	word ptr [edi],ax
		add	[out_crt],2
		add	[addr_crt],2	
	.ELSEIF [flag_dword]==1
		mov	[edi],eax
		add	[out_crt],4
		add	[addr_crt],4		
	.ELSE
		;---------------------
		; no "byte ptr"
		; so check label size
		;---------------------
		.IF [par1_size]==1
			mov	byte ptr [edi],al
			add	[out_crt],1
			add	[addr_crt],1

		.ELSEIF [par1_size]==2
			mov	word ptr [edi],ax
			add	[out_crt],2
			add	[addr_crt],2

		.ELSEIF [par1_size]==4
			mov	[edi],eax
			add	[out_crt],4
			add	[addr_crt],4		
		.ELSE
			;-----------------------
			; unknown assume dword
			;-----------------------
			mov	[edi],eax
			add	[out_crt],4
			add	[addr_crt],4
		.ENDIF
	.ENDIF

	ret
ENDP

;==============================
; Mov eax,[ebx]
;==============================
Encode_MOV_Reg_RegInd PROC
	USES	ebx,esi,edi
	ARG	@@reg1,@@reg2:dword

	ODS1	<"+++Encode MOV Reg,[Reg]">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode1
	; 1000101w
	;--------------------------
	.IF [par1_size]==32
		ODS1	<"Size is 32 bits">
		mov	al,10001011b
	.ELSEIF [par1_size]==16
		ODS1	<"Size is 16 bits">
		;-------------------------
		; emit prefix
		;-------------------------
		mov	al,066h
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1
		;-----------------
		; opcode	
		;-----------------	
		mov	al,10001011b

	.ELSEIF [par1_size]==8
		ODS1	<"Size is 08 bits">
		mov	al,10001010b
	.ENDIF

	mov	byte ptr [edi],al
	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;-------------------------
	;ebp is special case
	;-------------------------
	.IF [@@reg2]==5
		jmp	@@for_ebp
	.ENDIF

	;----------------------
	; write opcode2
	; Simple Modrm:
	; 00 reg1 reg2
	;----------------------
	mov	al,00000000b
	mov	ebx,[@@reg2]
	or	al,bl

	mov	ebx,[@@reg1]
	shl	ebx,3
	or	al,bl	

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;------------------------------
	; [esp]=4 is special case
	; encoded as [esp+0]
	; because
	; r/m=04=[esp] actually means:
	; "SIB folows" after modrm
	;------------------------------
	.IF [@@reg2]==4
		;----------------------
		; simple SIB
		; 00 100 100
		; scale = zero
		; index = none=4
		; base	= esp=4
		;----------------------
		mov	al,24h
		mov	byte ptr [edi],al
		add	[out_crt],1
		add	[addr_crt],1		
	.ENDIF

	ret

@@for_ebp:
	;----------------------
	; write opcode2
	;----------------------
	; Change Mod/R/M to
	; 01 reg1 101
	; reg1,disp8[ebp]
	;----------------------
	; because
	; M=101==disp32 not [ebp]
	; :P hacked CPU?
	;----------------------
	mov	al,01000101b

	mov	ebx,[@@reg1]
	shl	ebx,3
	or	al,bl	

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;------------------------------
	; write opcode3
	; null displacement
	;------------------------------
	mov	al,0
	mov	byte ptr [edi],al
	add	[out_crt],1
	add	[addr_crt],1

	ret		
ENDP

;==============================
; Mov [eax],ebx
;==============================
Encode_MOV_RegInd_Reg PROC
	USES	ebx,esi,edi
	ARG	@@reg1,@@reg2:dword

	ODS1	<"+++Encode MOV [reg1],reg2">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; opcode1
	; 1000100w
	;--------------------------
	.IF [par2_size]==32
		ODS1	<"Size is 32 bits">
		mov	al,10001001b
	.ELSEIF [par2_size]==16
		ODS1	<"Size is 16 bits">
		;-------------------------
		; emit prefix
		;-------------------------
		mov	al,066h
		mov	byte ptr [edi],al
		inc	edi
		add	[out_crt],1
		add	[addr_crt],1
		;-----------------
		; opcode	
		;-----------------	
		mov	al,10001001b

	.ELSEIF [par2_size]==8
		ODS1	<"Size is 08 bits">
		mov	al,10001000b
	.ENDIF

	;------------------
	; write opcode
	;------------------
	mov	byte ptr [edi],al
	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;-------------------------
	;ebp is special case
	;-------------------------
	.IF [@@reg1]==5
		jmp	@@for_ebp
	.ENDIF

	;----------------------
	; write opcode2
	; Simple Modrm:
	; 00 reg1 reg2
	;----------------------
	mov	al,00000000b
	mov	ebx,[@@reg1]
	or	al,bl

	mov	ebx,[@@reg2]
	shl	ebx,3
	or	al,bl	

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;------------------------------
	; [esp]=4 is special case
	; encoded as [esp+0]
	; because
	; r/m=04=[esp] actually means:
	; "SIB folows" after modrm
	;------------------------------
	.IF [@@reg1]==4
		;----------------------
		; simple SIB
		; 00 100 100
		; scale = zero
		; index = none=4
		; base	= esp=4
		;----------------------
		mov	al,24h
		mov	byte ptr [edi],al
		add	[out_crt],1
		add	[addr_crt],1		
	.ENDIF

	ret

@@for_ebp:
	;----------------------
	; write opcode2
	;----------------------
	; Change Mod/R/M to
	; 01 reg1 101
	; reg1,disp8[ebp]
	;----------------------
	; because
	; M=101==disp32 not [ebp]
	; :P hacked CPU?
	;----------------------
	mov	al,01000101b

	mov	ebx,[@@reg2]
	shl	ebx,3
	or	al,bl	

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;------------------------------
	; write opcode3
	; null displacement
	;------------------------------
	mov	al,0
	mov	byte ptr [edi],al
	add	[out_crt],1
	add	[addr_crt],1

	ret		
ENDP

;==============================
; Mov [eax],1234h
;==============================
Encode_MOV_RegInd_Imed PROC
	USES	ebx,esi,edi
	ARG	@@reg1,@@imediate:dword

	ODS1	<"+++Encode MOV [reg1],imed">

	mov	edi,[out_crt]
	add	edi,[lp_out_buff]

	;--------------------------
	; write opcode
	; 1100 011w
	;--------------------------
	mov	al,11000111b
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;-------------------------
	;ebp is special case
	;-------------------------
	.IF [@@reg1]==5
		jmp	@@for_ebp
	.ENDIF

	;----------------------
	; write opcode2
	; Simple Modrm:
	; Mod=xx Ext=000 R/M=reg
	;----------------------
	mov	al,00000000b
	mov	ebx,[@@reg1]
	or	al,bl

	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1



	;------------------------------
	; [esp]=4 is special case
	; encoded as [esp+0]
	; because
	; r/m=04=[esp] actually means:
	; "SIB folows" after modrm
	;------------------------------
	.IF [@@reg1]==4
		;----------------------
		; simple SIB
		; 00 100 100
		; scale = zero
		; index = none=4
		; base	= esp=4
		;----------------------
		mov	al,24h
		mov	byte ptr [edi],al

		inc	edi
		add	[out_crt],1
		add	[addr_crt],1		
	.ENDIF


	;--------------------
	;write the immediate
	;--------------------
	mov	eax,[@@imediate]
	mov	[edi],eax

	add	edi,4
	add	[out_crt],4
	add	[addr_crt],4


	ret

@@for_ebp:
	;----------------------
	; write opcode2
	;----------------------
	; Change Mod/R/M to
	; mov [ebp+0],1234
	;----------------------
	; because
	; M=101==disp32 not [ebp]
	; :P hacked CPU?
	;----------------------
	;M=01 R=000 R/M=101=[EBP]
	;----------------------
	mov	al,01000101b
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1

	;------------------------------
	; write opcode3
	; null displacement
	;------------------------------
	mov	al,0
	mov	byte ptr [edi],al

	inc	edi
	add	[out_crt],1
	add	[addr_crt],1


	;--------------------
	;write the immediate
	;--------------------
	mov	eax,[@@imediate]
	mov	[edi],eax

	add	edi,4
	add	[out_crt],4
	add	[addr_crt],4

	ret		
ENDP

;=====================================
; mov eax,[esi+4*ecx+1234h]
; mov [esi+4*ecx+1234h],eax
;=====================================
Encode_MOV_Reg_ModRM PROC
	USES 	esi,edi
	ARG	@@reg1,@@opcode:dword

	ODS1	<"+++Encode MOV reg1,[base+k*index+disp32">

	ODS1	<"Modrm scale:">
	ODV	[modrm_scale]
	ODV	[flag_modrm_scale]

	ODS1	<"Modrm index:">
	ODV	[modrm_index]	
	ODV	[flag_modrm_index]
		
	ODS1	<"Modrm base:">
	ODV	[modrm_base]
	ODV	[flag_modrm_base]

	ODS1	<"Modrm Displ:">
	ODV	[modrm_disp]
	ODV	[flag_modrm_disp]

	;------------------------
	; break into CASE's
	; based on expressions
	; number of terms ;)
	;------------------------
	.IF [factor_nr]==2

		ODS1	<"Factors 2">

		mov	eax,[flag_modrm_base]
		and	eax,[flag_modrm_disp]
		.IF !ZERO?
			ODS1	<"Base+Disp">
			;-------------------
			; simple base+disp
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			; 1000101w
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			mov	eax,[modrm_disp]
			cmp	eax,256
			.IF !CARRY?
				;-----------------------
				; big displacement 32
				;-----------------------
				; Write Mod R/M
				; 10 reg m/r -disp32
				;-----------------------
				mov	eax,10000000b		;Mod=10, ext=100 R/M=reg
				or	eax,[modrm_base]
				mov	ecx,[@@reg1]
				shl	ecx,3
				or	eax,ecx
				mov	byte ptr [edi],al

				inc	edi
				add	[addr_crt],1
				add	[out_crt],1	

				;----------------------------
				; displacement32
				;----------------------------
				mov	eax,[modrm_disp]
				mov	dword ptr [edi],eax
	
				add	[addr_crt],4
				add	[out_crt],4			
				ret
			.ELSE
				;-----------------------
				; small displacement 8
				;-----------------------
				; Write Mod R/M
				; 01 reg m/r -displ8
				;-----------------------
				mov	eax,01000000b		;Mod=10, ext=100 R/M=reg
				or	eax,[modrm_base]
				mov	ecx,[@@reg1]
				shl	ecx,3
				or	eax,ecx
				mov	byte ptr [edi],al

				inc	edi
				add	[addr_crt],1
				add	[out_crt],1	

				;----------------------------
				; displacement32
				;----------------------------
				mov	eax,[modrm_disp]
				mov	byte ptr [edi],al
	
				add	[addr_crt],1
				add	[out_crt],1			
				ret				
			.ENDIF

		.ENDIF

		mov	eax,[flag_modrm_base]
		and	eax,[flag_modrm_index]
		.IF !ZERO?
			ODS1	<"Base+Index">
			;-------------------
			;simple base+index
			;no displacement
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			; 1000 101w = 8B usually
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			;---------------------------------------
			;Write Mod R/M
			;Mod=00, reg=xxx R/M=100=SIB follows
			;---------------------------------------
			mov	eax,00000100b		
			;or	eax,[modrm_base]
			mov	ecx,[@@reg1]
			shl	ecx,3
			or	eax,ecx
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			;----------------------------
			; Scale
			;----------------------------
			mov	eax,[modrm_scale]
			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			;---------------------------
			; write SIB
			;---------------------------
			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,[modrm_base]
			or	eax,ebx	

			mov	byte ptr [edi],al
			
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1		

			ret
		.ENDIF


		mov	eax,[flag_modrm_index]
		and	eax,[flag_modrm_disp]
		.IF !ZERO?
			ODS1	<"Index+Displ">
			;-------------------
			;index
			;+displacement
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			; 1000101w
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			;---------------------------------------
			;Write Mod R/M
			;Mod=00, reg=xxx R/M=100=SIB follows
			;---------------------------------------
			mov	eax,00000100b		
			mov	ecx,[@@reg1]
			shl	ecx,3
			or	eax,ecx
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			;----------------------------
			; Scale
			;----------------------------
			mov	eax,[modrm_scale]
			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			;---------------------------
			; write SIB
			;---------------------------
			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,101b		;base=none if mod=00
			or	eax,ebx	

			mov	byte ptr [edi],al
			
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1		


			;----------------------------
			; displacement32
			;----------------------------
			mov	eax,[modrm_disp]
			mov	dword ptr [edi],eax
	
			add	[addr_crt],4
			add	[out_crt],4	

			ret
		.ENDIF

	.ELSEIF [factor_nr]==3
		;----------------------------
		; most complicated version
		;----------------------------
		mov	edi,[out_crt]
		add	edi,[lp_out_buff]
		;--------------------------
		; write opcode
		; 1000 101w =8B for w=1
		;--------------------------
		mov	eax,[@@opcode]
		mov	byte ptr [edi],al

		inc	edi
		inc	[out_crt]	
		inc	[addr_crt]


		mov	eax,[modrm_disp]
		cmp	eax,256
		.IF !CARRY?	
			;------------------------------------------
			; big displacement 32
			;------------------------------------------
			; Write Mod R/M
			; Mod=10, Reg=xxx R/M=100=4=disp32+SIB
			;------------------------------------------
			mov	eax,10000100b
		
			mov	ecx,[@@reg1]
			shl	ecx,3
			or	eax,ecx
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

	
			mov	eax,[modrm_scale]

			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,ebx
			or	eax,[modrm_base]

			ODS1	<"SIB:">
			ODVh	eax

			mov	byte ptr [edi],al
		
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1
			;----------------------------
			; displacement32
			;----------------------------
			mov	eax,[modrm_disp]
			mov	dword ptr [edi],eax

			add	[addr_crt],4
			add	[out_crt],4	
		.ELSE
			;------------------------------------------
			; small displacement 8
			;------------------------------------------
			; Write Mod R/M
			; Mod=01, Reg=xxx R/M=100=4=disp8+SIB
			;------------------------------------------
			mov	eax,01000100b
	
			mov	ecx,[@@reg1]
			shl	ecx,3
			or	eax,ecx
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			mov	eax,[modrm_scale]

			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,ebx
			or	eax,[modrm_base]

			ODS1	<"SIB:">
			ODVh	eax

			mov	byte ptr [edi],al
		
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1
			;----------------------------
			; displacement32
			;----------------------------
			mov	eax,[modrm_disp]
			mov	byte ptr [edi],al

			add	[addr_crt],1
			add	[out_crt],1	
		.ENDIF		
	.ENDIF


	ret
Encode_MOV_Reg_ModRM ENDP


;=====================================
; mov eax,[esi+4*ecx+1234h]
; mov [esi+4*ecx+1234h],eax
;=====================================
Encode_MOV_ModRM_Imed PROC
	USES 	esi,edi
	ARG	@@value,@@opcode:dword

	ODS1	<"+++Encode MOV [base+k*index+disp32],1234h">

	ODS1	<"Modrm scale:">
	ODV	[modrm_scale]
	ODV	[flag_modrm_scale]

	ODS1	<"Modrm index:">
	ODV	[modrm_index]	
	ODV	[flag_modrm_index]
		
	ODS1	<"Modrm base:">
	ODV	[modrm_base]
	ODV	[flag_modrm_base]

	ODS1	<"Modrm Displ:">
	ODV	[modrm_disp]
	ODV	[flag_modrm_disp]

	;------------------------
	; break into CASE's
	; based on expressions
	; number of terms ;)
	;------------------------
	.IF [factor_nr]==2

		ODS1	<"Factors 2">

		mov	eax,[flag_modrm_base]
		and	eax,[flag_modrm_disp]
		.IF !ZERO?
			ODS1	<"Base+Disp">
			;-------------------
			; simple base+disp
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			; 1000101w
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			mov	eax,[modrm_disp]
			cmp	eax,256
			.IF !CARRY?
				;-----------------------
				; big displacement 32
				;-----------------------
				; Write Mod R/M
				; Mod=10 Ext=000 R/M=Reg + disp32
				;--------------------------------------
				mov	eax,10000000b
				or	eax,[modrm_base]
				mov	byte ptr [edi],al

				inc	edi
				add	[addr_crt],1
				add	[out_crt],1	

				;----------------------------
				; displacement32
				;----------------------------
				mov	eax,[modrm_disp]
				mov	dword ptr [edi],eax
	
				add	[addr_crt],4
				add	[out_crt],4			
				ret
			.ELSE
				;-----------------------
				; small displacement 8
				;-----------------------
				; Write Mod R/M
				; Mod=01 Ext=000 R/M=Reg 
				; +displ8
				;-----------------------
				mov	eax,01000000b	
				or	eax,[modrm_base]
				mov	byte ptr [edi],al

				inc	edi
				add	[addr_crt],1
				add	[out_crt],1	

				;----------------------------
				; displacement32
				;----------------------------
				mov	eax,[modrm_disp]
				mov	byte ptr [edi],al
				add	edi,4	
				add	[addr_crt],1
				add	[out_crt],1
				;----------------------------
				; value 32
				;----------------------------
				mov	eax,[@@value]
				mov	dword ptr [edi],eax
				add	[addr_crt],4
				add	[out_crt],4	

			
				ret				
			.ENDIF


		.ENDIF

		mov	eax,[flag_modrm_base]
		and	eax,[flag_modrm_index]
		.IF !ZERO?
			ODS1	<"Base+Index">
			;-------------------
			;simple base+index
			;no displacement
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			;---------------------------------------
			;Write Mod R/M
			;Mod=00, Ext=000 R/M=100=SIB follows
			;---------------------------------------
			mov	eax,00000100b		
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			;----------------------------
			; Scale
			;----------------------------
			mov	eax,[modrm_scale]
			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			;---------------------------
			; write SIB
			;---------------------------
			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,[modrm_base]
			or	eax,ebx		;SIB

			mov	byte ptr [edi],al
			
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1		

			;----------------------------
			; value 32
			;----------------------------
			mov	eax,[@@value]
			mov	dword ptr [edi],eax
			add	[addr_crt],4
			add	[out_crt],4	

			ret
		.ENDIF


		mov	eax,[flag_modrm_index]
		and	eax,[flag_modrm_disp]
		.IF !ZERO?
			ODS1	<"Index+Displ">
			;-------------------
			; index
			; +displacement
			;-------------------
			mov	edi,[out_crt]
			add	edi,[lp_out_buff]
			;--------------------------
			; write opcode1
			;--------------------------
			mov	eax,[@@opcode]
			mov	byte ptr [edi],al
			inc	edi
			add	[out_crt],1
			add	[addr_crt],1

			;---------------------------------------
			; Write Mod R/M
			; Mod=00, Ext=000 R/M=100=SIB follows
			;---------------------------------------
			mov	eax,00000100b		
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			;----------------------------
			; Scale
			;----------------------------
			mov	eax,[modrm_scale]
			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			;---------------------------
			; write SIB
			;---------------------------
			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,101b		;base=none if mod=00
			or	eax,ebx	

			mov	byte ptr [edi],al
			
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1		

			;----------------------------
			; displacement32
			;----------------------------
			mov	eax,[modrm_disp]
			mov	dword ptr [edi],eax
			add	edi,4
			add	[addr_crt],4
			add	[out_crt],4

			;----------------------------
			; value 32
			;----------------------------
			mov	eax,[@@value]
			mov	dword ptr [edi],eax
			add	[addr_crt],4
			add	[out_crt],4	
	

			ret
		.ENDIF

	.ELSEIF [factor_nr]==3
		;----------------------------
		; most complicated version
		;----------------------------
		mov	edi,[out_crt]
		add	edi,[lp_out_buff]
		;--------------------------
		; write opcode
		;--------------------------
		mov	eax,[@@opcode]
		mov	byte ptr [edi],al

		inc	edi
		inc	[out_crt]	
		inc	[addr_crt]


		mov	eax,[modrm_disp]
		cmp	eax,256
		.IF !CARRY?	
			;------------------------------------------
			; big displacement 32
			;------------------------------------------
			; Write Mod R/M
			; Mod=10, Ext=000 R/M=100=4=>disp32+SIB
			;------------------------------------------
			mov	eax,10000100b
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

	
			mov	eax,[modrm_scale]

			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,ebx
			or	eax,[modrm_base]

			ODS1	<"SIB:">
			ODVh	eax

			mov	byte ptr [edi],al
		
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1
			;----------------------------
			; displacement32
			;----------------------------
			mov	eax,[modrm_disp]
			mov	dword ptr [edi],eax
			add	edi,4
			add	[addr_crt],4
			add	[out_crt],4	
		.ELSE
			;------------------------------------------
			; small displacement 8
			;------------------------------------------
			; Write Mod R/M
			; Mod=01, Reg=xxx R/M=100=4=disp8+SIB
			;------------------------------------------
			mov	eax,01000100b
			mov	byte ptr [edi],al

			inc	edi
			add	[addr_crt],1
			add	[out_crt],1	

			mov	eax,[modrm_scale]

			.IF eax==0
				mov	ebx,0
			.ELSEIF eax==2
				mov	ebx,01000000b
			.ELSEIF eax==4
				mov	ebx,10000000b
			.ELSEIF eax==8
				mov	ebx,11000000b
			.ELSE
				;---------------
				;error
				;---------------
				mov	ebx,0
			.ENDIF

			mov	eax,[modrm_index]
			shl	eax,3
			or	eax,ebx
			or	eax,[modrm_base]

			ODS1	<"SIB:">
			ODVh	eax

			mov	byte ptr [edi],al
		
			inc	edi
			add	[addr_crt],1
			add	[out_crt],1
			;----------------------------
			; displacement8
			;----------------------------
			mov	eax,[modrm_disp]
			mov	byte ptr [edi],al

			add	edi,1
			add	[addr_crt],1
			add	[out_crt],1	
		.ENDIF
		;----------------------------
		; value 32
		;----------------------------
		mov	eax,[@@value]
		mov	dword ptr [edi],eax
		add	[addr_crt],4
		add	[out_crt],4			
	.ENDIF


	ret
Encode_MOV_ModRM_Imed ENDP
