;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;******************************
; Encode Simple Instructions
;
; aka 1,2 opcodes w/o params
;******************************

;======================
;Encode for PROC's
;======================
Encode_LEAVE PROC
	USES	edi

	mov	edi,[lp_out_buff]
	add	edi,[out_crt]

	mov	al,0C9h
	mov	byte ptr [edi],al

	add	[out_crt],1
	add	[addr_crt],1

	ret
ENDP

Encode_ENTER PROC
	USES	edi
	ARG	@@local_size,@@enter_level:dword

	ODS1	<"+++Encode Enter">

	mov	edi,[lp_out_buff]
	add	edi,[out_crt]

	;---------------------
	; 1: opcode
	;---------------------
	mov	al,0C8h
	mov	byte ptr [edi],al
	inc	edi

	;-----------------------------
	;2:local size
	;-----------------------------
	mov	eax,[@@local_size]
	mov	word ptr [edi],ax
	add	edi,2

	;---------------------
	; 3: enter level
	;---------------------
	mov	eax,[@@enter_level]
	mov	byte ptr [edi],al	

	add	[out_crt],4
	add	[addr_crt],4

	ret	
ENDP


;==================================
;Simple 1 byte instruction
;with no params needed
;==================================
On_Inst_1byte PROC
	USES	esi,edi
	ARG	@@param:DWORD

	;ODS1	<"+++On Instr 1byte">

	mov	edi,[lp_out_buff]
	add	edi,[out_crt]
	;----------------------
	;get first param
	;----------------------
	mov	esi,[@@param]
	add	esi,4
	;-----------------------
	; encode opcode 1
	;-----------------------
	mov	eax,[esi]
	mov	byte ptr [edi],al

	inc	[out_crt]
	inc	[addr_crt]

	ret
ENDP

On_Inst_2byte PROC
	USES	esi,edi
	ARG	@@param:DWORD

	;ODS1	<"+++On Instr 2byte">
	;---------------------------
	;calculate output location
	;---------------------------
	mov	edi,[lp_out_buff]
	add	edi,[out_crt]

	;-----------------------------
	;get first param=opcode 1
	;-----------------------------
	mov	esi,[@@param]
	add	esi,4


	mov	eax,[esi]
	mov	byte ptr [edi],al

	;ODVh	eax	

	;----------------------
	; next:opcode 2
	;----------------------
	add	esi,4
	inc	edi


	mov	eax,[esi]
	mov	byte ptr [edi],al
	
	;ODVh	eax

	add	[out_crt],2
	add	[addr_crt],2

	ret
ENDP

