;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;*****************************************
; On Have Token
;*****************************************

;=====================================
; What to do with a token just found?
; kind of main dispatcher routine
;
; On entry:
;	esi==parse position
;=====================================

On_Have_Token PROC
	USES	esi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++On Have Token:">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODS2	<"len:">
	ODV	[@@token_size]
	ODS2	<"mode:">
	ODV	[parse_mode]

	;---------------------------------
	; actions depend on "MODE"
	; some tokens just get us in a "mode"
	; and we later react here ;)
	;---------------------------------	
	.IF [parse_mode]==P2_MODE_DEFAULT
		Call	On_Mode_Default,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_STRU
		Call	On_Mode_STRU,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_MOV1
		Call	On_Mode_MOV1,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_MOV2
		Call	On_Mode_MOV2,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_LOCAL
		Call	On_Mode_LOCAL,[@@token_start],[@@token_size]

	.ELSEIF [parse_mode]==P2_MODE_ARG
		Call	On_Mode_ARG,[@@token_start],[@@token_size]

	.ELSEIF [parse_mode]==P2_MODE_USES
		Call	On_Mode_USES,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_POP
		Call	On_Mode_POP,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_PUSH
		Call	On_Mode_PUSH,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_RETN
		Call	On_Mode_RETN,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_ORG
		Call	On_Mode_ORG,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_DISP
		Call	On_Mode_DISP,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_JMP		
		Call	On_Mode_JMP,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_CALL		
		Call	On_Mode_CALL,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_INCLUDE
		ODS1	<"Mode Include">
		;---------------------------------
		; indirect recursive call
		;---------------------------------
		Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
		Call	Parse_File,offset sz_tmp1
		;-----------------------------------
		; Warning!:
		;-----------------------------------
		; can not continue a token/stru/etc
		; from a previouse file
		;-----------------------------------
		mov		[parse_mode],P2_MODE_DEFAULT
		
	.ELSEIF [parse_mode]==P2_MODE_DEFINE_B
		Call	On_Mode_DW,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_DEFINE_W
		Call	On_Mode_DW,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_DEFINE_D
		Call	On_Mode_DD,[@@token_start],[@@token_size]
		
	.ENDIF
	ret
ENDP

;=====================================
; NO Hints in this mode ;)
;=====================================
On_Mode_Default PROC
	USES	ebx,ecx
	ARG		@@token_start,@@token_size:dword

	ODS1	<"+++On Mode Default">

	mov	al,[char_old]
	.IF al==":"
		;----------------------------
		; simple label ;)
		;----------------------------
		; ignore trailing ":"
		;----------------------------
		mov	eax,[@@token_size]
		dec	eax
		mov	[@@token_size],eax
		.IF ZERO?
			Call	Print_Error,offset sz_err_007,[@@token_start],[@@token_size]	
			mov	[parse_mode],P2_MODE_DEFAULT
			ret
		.ENDIF			
			
			
		.IF [pass_nr]==1
			Call	Check_Label,[@@token_start],[@@token_size]
			.IF eax==-1
				Call	Create_Label,[@@token_start],[@@token_size],LABEL_CODE,[addr_crt]
			.ELSE
				; label already defined
				Call	Print_Error,offset sz_err_008,[@@token_start],[@@token_size]
			.ENDIF			
		.ELSE
			Call	Check_Label,[@@token_start],[@@token_size]
			.IF eax==-1
				; undefined label 
				Call	Print_Error,offset sz_err_009,[@@token_start],[@@token_size]
			.ENDIF
		.ENDIF
	.ELSE
		;---------------------------------
		; Not a simple colon label:
		; is token or data label?
		;---------------------------------
		Call	Check_Token,[@@token_start],[@@token_size]
		.IF eax==-1
			;--------------------------------------
			; NOT a token, maybe is a name for
			; data label/proc/macro/structure?
			; Peek returns:
			; 	ebx=new token start
			; 	ecx=new token size
			;--------------------------------------
			Call	Peek_Line_For_Token,esi
			.IF eax==-1
				;--------------------------------
				; nothing after it, hmmmm
				; single unknown token on a line
				;--------------------------------
				Call	Print_Error,offset sz_err_001,[@@token_start],[@@token_size]
			.ELSE
				;-----------------------------------------
				; check for: dd,db,dw,proc,struc
				;-----------------------------------------
				Call	Check_Token,ebx,ecx
				.IF eax==-1
					Call	Print_Error,offset sz_err_001,[@@token_start],[@@token_size]
					ret
				.ENDIF
					
					
				;------------------------------
				; save crt parse modes
				;------------------------------
				mov	eax,[parse_mode]
				mov	[parse_mode_old],eax
				
				mov	ebx,[parse_hll_mode]
				mov	[parse_hll_mode_old],ebx
				
				;------------------------------
				; go into the future ;)
				;------------------------------
				; early execute token method
				; to detect token type
				;------------------------------
				;pushad
				
				mov	eax,[token_method]
				mov	ebx,[token_params]
				Call	eax,ebx
				
				;popad
				
				;--------------------------------
				; pass dependant
				;--------------------------------
				; creation is
				; mainly in pass 1 :-?
				;--------------------------------
				.IF [pass_nr]==1	
					.IF [parse_hll_mode]==P2_HLL_DEFAULT
						Call	Check_Label,[@@token_start],[@@token_size]
						.IF eax==-1
							;-----------------------
							; not defined
							;-----------------------
							Call	Create_Label,[@@token_start],[@@token_size],LABEL_DATA,[addr_crt]
						.ELSE
							;-----------------------
							; err already defined
							;-----------------------
							Call	Print_Error,offset sz_err_008,[@@token_start],[@@token_size]
						.ENDIF
						
					.ELSEIF [parse_hll_mode]==P2_HLL_PROC_START
						Call	Create_Proc,[@@token_start],[@@token_size],[addr_crt]
						
					.ELSEIF [parse_hll_mode]==P2_HLL_STRU_START
						.IF [parse_mode]==P2_MODE_STRU
							Call	Check_Structure,[@@token_start],[@@token_size]
							.IF eax==-1
								;----------------
								; not defined
								;----------------
								Call	Create_Structure,[@@token_start],[@@token_size],[addr_crt]
							.ELSE
								;-----------------------
								; err already defined
								;-----------------------
								Call	Print_Error,offset sz_err_036,[@@token_start],[@@token_size]
								
							.ENDIF
							
						.ELSEIF [parse_mode]==P2_MODE_DEFINE_D
								Call	Create_Stru_Member,[@@token_start],[@@token_size]
								
						.ENDIF
					.ENDIF
					
				.ELSEIF [pass_nr]==2
					.IF [parse_hll_mode]==P2_HLL_PROC_START
						Call	Check_Proc,[@@token_start],[@@token_size]
						.IF eax==-1	
							;----------------------------
							;funny proc not found error
							;assume pass dependant error
							;----------------------------
							Call	Print_Error,offset sz_err_035,[@@token_start],[@@token_size]
						.ELSE
							;----------------------------
							; this is our "body"
							;----------------------------
							mov	[proc_crt],ecx
						.ENDIF
						
					.ELSEIF [parse_hll_mode]==P2_HLL_STRU_START
						.IF [parse_mode]==P2_MODE_STRU
							Call	Check_Structure,[@@token_start],[@@token_size]
							.IF eax==-1
								;----------------------------
								;funny struc not found error
								;assume pass dependant error
								;----------------------------
								Call	Print_Error,offset sz_err_035,[@@token_start],[@@token_size]
							.ELSE
								;----------------------------
								; this is our "body"
								;----------------------------
								mov	[stru_crt],ecx	
							.ENDIF
						.ELSEIF [parse_mode]==P2_MODE_DEFINE_D
							
						.ENDIF
						
					.ENDIF
					
				.ENDIF
				
				;-------------------------------------
				; restore previouse  modes "as if"
				; "als ob" I was never here
				;-------------------------------------
				mov		eax,[parse_mode_old]
				mov		[parse_mode],eax
				
				mov		ebx,[parse_hll_mode_old]
				mov		[parse_hll_mode],ebx
				
			.ENDIF
		.ELSE
			;----------------------------------
			; its a normal token
			; first check advanced modes
			;----------------------------------
			.IF [parse_hll_mode]==P2_HLL_PROC_START
				mov	eax,[token_type]
				and	eax,TYPE_OPCODE
				.IF !ZERO?
					;---------------------------------
					; generate prologue before
					; the first instruction in proc
					;---------------------------------
					Call	Generate_Prologue
					mov	[parse_hll_mode],P2_HLL_PROC_BODY
				.ENDIF
				
			.ELSEIF [parse_hll_mode]==P2_HLL_STRU_START
				
			.ENDIF
			
			;-------------------------
			; execute token's method
			;-------------------------
			pushad
			mov	eax,[token_method]
			mov	ebx,[token_params]
			Call	eax,ebx
			popad
		.ENDIF
	.ENDIF
	ret

ENDP

;====================================
;Multi line Mode
;====================================
On_Mode_STRU PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode STRU:">
	nop

	ret
ENDP

On_Mode_USES PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode USES:">

	;-----------------------------
	;after pass1 all uses are done
	;-----------------------------
	.IF [pass_nr]>1
		ret
	.ENDIF

	.IF [proc_crt]==-1
		Call	Print_Error,offset sz_err_026,[@@token_start],[@@token_size]
		ret		
	.ENDIF

	ODS2	<"for proc id:">
	ODVh	eax
	
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not a register
		;-------------------------------------
		Call	Print_Error,offset sz_err_025,[@@token_start],[@@token_size]		
	.ELSE
		;-----------------------------------
		; add this register to the proc's list
		;-----------------------------------			

		;-------------------------
		;calc PROC stru base addr
		;-------------------------
		mov	esi,offset proc_base0
		;mov	ecx,SIZE PROC_STRU
		;mul	ecx
		;add	esi,eax

		mov	edi,esi
		add	edi,offset proc_uses_regs
		
		mov	eax,[esi.proc_uses_nr]
		
		ODS1	<"Initial uses_nr:">
		ODVh	eax
		
		shl	eax,2
		add	edi,eax

		mov	[edi],ebx			;write register

		mov	eax,[esi.proc_uses_nr]
		inc	eax
		and	eax,01Fh			;max 32 saves
		mov	[esi.proc_uses_nr],eax
		
		ODS1	<"Finish uses_nr:">
		ODVh	eax

	.ENDIF

	ret
ENDP

On_Mode_ARG PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode ARG">

	.IF [proc_crt]==-1
		Call	Print_Error,offset sz_err_027,[@@token_start],[@@token_size]
		ret		
	.ENDIF

	;---------------------------------
	; after pass1 all ARG's are done?
	;---------------------------------
	.IF [pass_nr]>1
		ret
	.ENDIF

	;-------------------------
	;calc PROC stru base addr
	;-------------------------
	mov	eax,[proc_crt]
	mov	esi,offset proc_base0
	mov	ebx,SIZE PROC_STRU
	mul	ebx
	add	esi,eax
	;-----------------------------
	; inc arguments nr
	;-----------------------------
	mov	eax,[esi.proc_arg_nr]
	inc	eax
	mov	[esi.proc_arg_nr],eax
	ODS1	<"ARG_NR:">
	ODV	eax
	;-----------------------------
	; bust size
	;-----------------------------
	mov	eax,[esi.proc_arg_size]
	add	eax,4				;default dword=4
	mov	[esi.proc_arg_size],eax
	ODS1	<"ARG_SIZE:">
	ODV	eax

	ret
ENDP

On_Mode_LOCAL PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode LOCAL">

	.IF [proc_crt]==-1
		Call	Print_Error,offset sz_err_027,[@@token_start],[@@token_size]
		ret		
	.ENDIF

	;---------------------------------
	; after pass1 all LOCAL's are done?
	;---------------------------------
	.IF [pass_nr]>1
		ret
	.ENDIF

	;-------------------------
	;calc PROC stru base addr
	;-------------------------
	mov	eax,[proc_crt]
	mov	esi,offset proc_base0
	mov	ebx,SIZE PROC_STRU
	mul	ebx
	add	esi,eax
	;-----------------------------
	; inc arguments nr
	;-----------------------------
	mov	eax,[esi.proc_local_nr]
	inc	eax
	mov	[esi.proc_local_nr],eax
	ODS1	<"LOCAL_NR:">
	ODV	eax
	;-----------------------------
	; bust size
	;-----------------------------
	mov	eax,[esi.proc_local_size]
	add	eax,4				;default dword=4
	mov	[esi.proc_local_size],eax
	ODS1	<"LOCAL_SIZE:">
	ODV	eax

	ret
ENDP

On_Mode_CALL PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"On Mode Call">

	;-----------------------
	; call eax
	;-----------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax!=-1
		ODS1	<"Register Found">
		ODV	ebx

		Call	Encode_CALL_Reg,ebx
		mov	[parse_mode],P2_MODE_DEFAULT
		ret		
	.ENDIF


	;-----------------------
	; Call label
	;-----------------------	
	Call	Check_Label,[@@token_start],[@@token_size]
	.IF eax!=-1
		Call	Encode_CALL_Label,ebx
	.ELSE
		Call	Check_Proc,[@@token_start],[@@token_size]
		.IF eax!=-1
			Call	Encode_CALL_Proc,ebx
		.ELSE
			.IF [pass_nr]==1
				ODS1	<"Encoding Dummy Call">
				mov	eax,[addr_crt]
				add	eax,5
				Call	Encode_CALL_Label,eax	
			.ELSE
				;-----------------------
				; jmp number
				;-----------------------
				Call	Check_Value,[@@token_start],[@@token_size]
				.IF eax==-1
					Call	Print_Error,offset sz_err_012,[@@token_start],[@@token_size]			
				.ELSE
					Call	Encode_CALL_Label,ebx	
				.ENDIF
			.ENDIF
		.ENDIF
	.ENDIF


	mov	[parse_mode],P2_MODE_DEFAULT
	ret
ENDP

On_Mode_PUSH PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"+++On Mode PUSH">

	;-----------------------
	; push register
	;-----------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax!=-1
		ODS1	<"PUSH Register Found">
		ODV	ebx

		Call	Encode_PUSH_Reg1,ebx
		mov	[parse_mode],P2_MODE_DEFAULT
		ret		
	.ENDIF

	mov	[parse_mode],P2_MODE_DEFAULT	
	ret
ENDP

On_Mode_POP PROC
	USES	esi,edi
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"+++On Mode POP">

	;-----------------------
	; pop register
	;-----------------------
	Call	Check_Register,[@@token_start],[@@token_size]
	.IF eax!=-1
		ODS1	<"POP Register Found">
		ODV	ebx

		Call	Encode_POP_Reg1,ebx
		mov	[parse_mode],P2_MODE_DEFAULT
		ret		
	.ENDIF

	mov	[parse_mode],P2_MODE_DEFAULT	
	ret
ENDP

On_Mode_ORG PROC
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"+On Mode ORG">

	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------
		Call	Print_Error,offset sz_err_011,[@@token_start],[@@token_size]
	.ELSE
		;----------------------------
		;change location counter(s)
		;----------------------------
		mov	[addr_crt],ebx
		mov	[out_crt],ebx
	.ENDIF


	mov	[parse_mode],P2_MODE_DEFAULT
	ret
ENDP

On_Mode_DISP PROC
	ARG 	@@token_start,@@token_size:dword

	ODS1	<"+On Mode DISP">

	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------
		Call	Print_Error,offset sz_err_011,[@@token_start],[@@token_size]
	.ELSE
		;-----------------------------------
		;change ONLY Output counter
		;and assume negative
		;leave location counter untouched
		;-----------------------------------
		mov	eax,[out_crt]
		sub	eax,ebx
		mov	[out_crt],eax

		ODV	eax
	.ENDIF


	mov	[parse_mode],P2_MODE_DEFAULT
	ret
ENDP

On_Mode_DD PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode Define Dword">

	;-------------------
	;fast check for "?"
	;-------------------
	.IF [@@token_size]==1
		mov	esi,[@@token_start]
		mov	al,byte ptr [esi]
		.IF al=="?"
			;------------------------
			;just advance position
			;------------------------
			add	[out_crt],4
			add	[addr_crt],4
			ret
		.ENDIF
	.ENDIF

	;-----------------------------------------
	;convert to number, result in eax,ebx
	;-----------------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------
		Call	Print_Error,offset sz_err_010,[@@token_start],[@@token_size]
	.ELSE
		;-----------------------
		; store this dword
		;-----------------------
		mov	eax,ebx
		mov	ebx,[out_crt]
		mov	edi,[lp_out_buff]
		mov	[edi+ebx],eax
		add	[out_crt],4
		add	[addr_crt],4
	.ENDIF
	ret
ENDP

On_Mode_DB PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++On Mode Define Byte">

	;-------------------
	;fast check for "?"
	;-------------------
	.IF [@@token_size]==1
		mov	esi,[@@token_start]
		mov	al,byte ptr [esi]
		.IF al=="?"
			;------------------------
			;just advance position
			;------------------------
			add	[out_crt],1
			add	[addr_crt],1
			ret
		.ENDIF
	.ENDIF

	;---------------------------------
	;convert to number, result in eax
	;---------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------			
		Call	Print_Error,offset sz_err_010,[@@token_start],[@@token_size]
	.ELSE
		.IF ebx>255
			Call	Print_Error,offset sz_err_003,[@@token_start],[@@token_size]
		.ENDIF
		;-----------------------
		; store this byte
		;-----------------------
		mov	eax,ebx
		mov	ebx,[out_crt]
		mov	edi,[lp_out_buff]
		mov	byte ptr [edi+ebx],al
		add	[out_crt],1
		add	[addr_crt],1
	.ENDIF
	ret
ENDP

On_Mode_DW PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++On Mode Define Word">

	;-------------------
	;fast check for "?"
	;-------------------
	.IF [@@token_size]==1
		mov	esi,[@@token_start]
		mov	al,byte ptr [esi]
		.IF al=="?"
			;------------------------
			;just advance position
			;------------------------
			add	[out_crt],2
			add	[addr_crt],2
			ret
		.ENDIF
	.ENDIF

	;---------------------------------
	; convert to number, result in eax
	;---------------------------------
	Call	Check_Value,[@@token_start],[@@token_size]
	.IF eax==-1
		;-------------------------------------
		; Not A Number
		;-------------------------------------
		Call	Print_Error,offset sz_err_010,[@@token_start],[@@token_size]
	.ELSE
		.IF ebx>65535
			Call	Print_Error,offset sz_err_003,[@@token_start],[@@token_size]
		.ENDIF
		;-----------------------
		; store this byte
		;-----------------------
		mov	eax,ebx
		mov	ebx,[out_crt]
		mov	edi,[lp_out_buff]
		mov	word ptr [edi+ebx],ax
		add	[out_crt],2
		add	[addr_crt],2
	.ENDIF
	ret
ENDP

