;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;*****************************************
; On Have Token Brackets
;*****************************************

;========================================
; What to do with a [token] just found?
; kind of main dispatcher routine
;----------------------------------------
; theoretically this kind of token
; requires Mod/R/M ... but not always
;========================================
On_Have_Token_Br PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++On Have Token Brackets">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>
	ODV	[@@token_size]

	;-----------------------------------------
	; actions depend on "MODE"
	; some tokens just get us in a "mode"
	; and we later react here
	;-----------------------------------------
	; but this reaction is specific to []
	;-----------------------------------------
	.IF [parse_mode]==P2_MODE_DEFAULT
		;-------------------------------------------
		;imposible to have brackets in default mode
		;-------------------------------------------
		Call	Print_Error,offset sz_err_020,[@@token_start],[@@token_size]
		
	.ELSEIF [parse_mode]==P2_MODE_JMP		
		Call	On_Mode_JMP_Br,[@@token_start],[@@token_size]

	.ELSEIF [parse_mode]==P2_MODE_MOV1
		Call	On_Mode_MOV1_Br,[@@token_start],[@@token_size]

	.ELSEIF [parse_mode]==P2_MODE_MOV2
		Call	On_Mode_MOV2_Br,[@@token_start],[@@token_size]
	.ELSE
		;-------------------------------------------
		;unknown mode/instruction
		;-------------------------------------------
		Call	Print_Error,offset sz_err_030,[@@token_start],[@@token_size]		
	.ENDIF
	ret
ENDP




