;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;==========================
; Parser Messages
;==========================
.data
;-----------------------
; Command line errors
;-----------------------
sz_no_filename_in	db	13,10,"Error:NO input filename specified",0

;--------------------
; Parse Errors
;--------------------
sz_err_000	db	13,10,"Error:",0
sz_err_001	db	"Unknown Instruction:",0
sz_err_002	db	13,10,"Can not open include file:",0
sz_err_003	db	"Number too big:",0
sz_err_004	db	"Empty string:",0
sz_err_005	db	"Can not take string here:",0
sz_err_006	db	"Can not create more labels:",0
sz_err_007	db	"Empty label:",0
sz_err_008	db	"Label already defined:",0
sz_err_009	db	"Label should exist:",0
sz_err_010	db	"Unknown number format:",0
sz_err_011	db	"Need number:",0
sz_err_012	db	"Label undefined:",0
sz_err_014	db	"Unknown expresion:",0
sz_err_015	db	"Bracket nesting not allowed:",0
sz_err_016	db	"Expecting end bracket:",0
sz_err_017	db	"Empty barckets?:",0
sz_err_018	db	"Unknown expresion:",0
sz_err_019	db	"Expecting start bracket:",0
sz_err_020	db	"Orphan barackets here:",0
sz_err_021	db	"Wrong address expresion:",0
sz_err_022	db	"Unknown option/switch:",0
sz_err_023	db	"Expecting end quote:",0
sz_err_024	db	"Can not create more procedures:",0
sz_err_025	db	"Expecting register here:",0
sz_err_026	db	"USES outside PROC:",0
sz_err_027	db	"ARG outside PROC:",0
sz_err_028	db	"Undefined symbol:",0
sz_err_029	db	"Can not use Immediate:",0
sz_err_030	db	"Unknown Mode or Menmonic:",0
sz_err_031	db	"Can not use here:",0
sz_err_032	db	"Unmached ENDP ?:",0
sz_err_033	db	"Can not create more structures:",0
sz_err_034	db	"Unmached ENDS ?:",0
sz_err_035	db	"Pass dependant error ?:",0
sz_err_036	db	"Structure already defined:",0
sz_err_037	db	"Can NOT create more structure members:",0
;--------------------
; OK Messages
;--------------------
sz_finish_ok	db	13,10,"[Parse Finished]",13,10,0


	align 4
	errors_count	dd	0
	sz_fmt_err01	db 	09,"In file:%s,line:[%i] ",0
.code
;================================
; Report an error to the console
;================================
;Print_Error PROTO :DWORD , :DWORD , :DWORD 
Print_Error PROC
	USES	esi

	ARG	@@lp_sz_msg:dword
	ARG	@@lp_token,@@token_size:dword

	ODS1	<"+++Print Error">


	inc	[errors_count]

	.IF [flag_option_errors]==1
		ret
	.ENDIF

	Call	Print_Text,offset sz_err_000
	Call	Print_Text,[@@lp_sz_msg]

	Call	Str_Copy_Nr,[@@lp_token],offset sz_tmp2,[@@token_size]
	Call	Print_Text,offset sz_tmp2

	Call	Get_Include_Context

	mov	esi,eax
	add	eax,include_file_name
		
	Call	wsprintfA,offset sz_tmp1, offset sz_fmt_err01,eax,[esi.include_line_crt],[text_line_crt]
	Call	Print_Text, offset sz_tmp1

	ret
ENDP

;Print_Error1 PROTO :DWORD 
Print_Error1 PROC
	USES	esi

	ARG	@@lp_sz_msg:dword

	ODS1	<"+++Print Error1">

	inc	[errors_count]

	.IF [flag_option_errors]==1
		ret
	.ENDIF

	Call	Print_Text,offset sz_err_000
	Call	Print_Text,[@@lp_sz_msg]

	;Call	Str_Copy_Nr,[@@lp_token],offset sz_tmp2,[@@token_size]
	;Call	Print_Text,offset sz_tmp2

	Call	Get_Include_Context

	mov	esi,eax
	add	eax,include_file_name
		
	Call	wsprintfA,offset sz_tmp1, offset sz_fmt_err01,eax,[esi.include_line_crt],[text_line_crt]
	Call	Print_Text, offset sz_tmp1

	ret
ENDP

;Print_Error0 PROTO :DWORD , :DWORD , :DWORD 
Print_Error0 PROC
	USES	esi
	ARG	@@lp_sz_msg:dword
	ARG	@@lp_token,@@token_size:dword

	ODS1	<"+++Print Error0">

	inc	[errors_count]

	Call	Print_Text,offset sz_err_000
	Call	Print_Text,[@@lp_sz_msg]

	Call	Str_Copy_Nr,[@@lp_token],offset sz_tmp2,[@@token_size]
	Call	Print_Text,offset sz_tmp2

	ret
ENDP


