;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------

;***********************************
;	String UTILS
;***********************************


;====================================
; String length including zero?
;====================================
Str_Len PROC 
	USES	ecx,esi
	ARG	@@lp_sz_str:DWORD

	mov	esi,[@@lp_sz_str]
	xor	ecx,ecx			

@@search_loop:
	inc	ecx
	mov	al,byte ptr [esi]
	test	al,al
	jz	@@found_finish
	
	inc	esi
	jmp	@@search_loop
	
@@found_finish:

	mov		eax,ecx			
	ret
	
ENDP


Str_Copy PROC 
	USES	ecx,esi,edi
	ARG	@@lpsz_src:dword
	ARG	@@lpsz_dest:dword

	xor	eax,eax	
	mov	esi,[@@lpsz_src]
	mov	edi,[@@lpsz_dest]

@@copy_loop:
	mov	al,byte ptr [esi]
	mov	byte ptr [edi],al

	test	al,al
	jz	@@finish_copy

	inc	esi
	inc	edi
	jmp	@@copy_loop

@@finish_copy:
	ret
ENDP


Str_Copy_Nr PROC 
	USES	ecx,esi,edi

	ARG	@@lpsz_src:dword
	ARG	@@lpsz_dest:dword
	ARG	@@nr_count:dword


	;ODS1	<"+++Str_Copy_Nr">
	;ODVh	[@@nr_count]

	mov	esi,[@@lpsz_src]
	mov	edi,[@@lpsz_dest]
	mov	ecx,[@@nr_count]

@@copy_src_loop:
	mov	al,byte ptr [esi]
	mov	byte ptr [edi],al
	inc	esi
	inc	edi
	dec	ecx
	jnz	@@copy_src_loop
	;-----------------------------
	; place terminator also
	;------------------------------
	mov	al,0
	mov	byte ptr [edi],al

	;ODS1	<"---Str_Copy_Nr">
	ret
ENDP
