;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;====================================
; some basic utils
;====================================
.data
	align 4
	sz_crlf		db	13,10,0
.data?
	align 4
	sz_tmp0		db	512 dup(?)
	sz_tmp1		db	512 dup(?)
	sz_tmp2		db	512 dup(?)
.code


;-----------------------------------------------------
; Macros for "debug" mode only
; have no effect on "release" mode
; undefine/comment both for "release"
; define debuf_file for most debug versions
;-----------------------------------------------------
;DEBUG_MODE	EQU	1
;DEBUG_FILE	EQU	1
.data
	sz_val1_fmt_li	db "dec=%li ",0
	sz_val1_fmt_lx	db "hexa=%lx ",0
	sz_crlf1	db 13,10,0	
.data?
	sz_val1		db 128 dup(?)
.code

ODS MACRO mpar1

	ifdef DEBUG_MODE
		pushad
		Call	OutputDebugStringA,mpar1
		popad
	endif

	ifdef DEBUG_FILE
		pushad
		Call	Str_Len,mpar1
		Call	WriteFile,[file_handle_ods],mpar1,eax,offset bytes_written,0
		;Call	WriteFile,[file_handle_ods],offset sz_crlf1,2,offset bytes_written,0
		popad
	endif
ENDM

ODV MACRO mpar1
	ifdef DEBUG_MODE
		pushad
		call	wsprintfA,offset sz_val1,offset sz_val1_fmt_li,mpar1
		call	OutputDebugStringA,offset sz_val1
		popad
	endif

	ifdef DEBUG_FILE
		pushad
		call	wsprintfA,offset sz_val1,offset sz_val1_fmt_li,mpar1
		Call	WriteFile,[file_handle_ods],offset sz_val1,eax,offset bytes_written,0
		;Call	WriteFile,[file_handle_ods],offset sz_crlf1,2,offset bytes_written,0
		popad
	endif
ENDM

ODVh MACRO mpar1
	ifdef DEBUG_MODE
		pushad
		call	wsprintfA,offset sz_val1,offset sz_val1_fmt_lx,mpar1
		call	OutputDebugStringA,offset sz_val1
		popad
	endif

	ifdef DEBUG_FILE
		pushad
		call	wsprintfA,offset sz_val1,offset sz_val1_fmt_lx,mpar1
		Call	WriteFile,[file_handle_ods],offset sz_val1,eax,offset bytes_written,0
		;Call	WriteFile,[file_handle_ods],offset sz_crlf1,2,offset bytes_written,0
		popad
	endif
ENDM

ODS1 MACRO mpar1
	LOCAL mstring1

	ifdef DEBUG_MODE
		.data
			mstring1	db mpar1
					db 0	
		.code
		pushad
		Call	OutputDebugStringA,offset mstring1
		popad
	endif


	ifdef DEBUG_FILE
		.data
		mstring1	db mpar1
				db 0	
	.code
		pushad
		Call	WriteFile,[file_handle_ods],offset sz_crlf1,2,offset bytes_written,0
		Call	Str_Len,offset mstring1
		Call	WriteFile,[file_handle_ods],offset mstring1,eax,offset bytes_written,0
		popad
	endif
ENDM

;-----------------------------
;Non CR version
;-----------------------------
ODS2 MACRO mpar1
	LOCAL mstring1

	ifdef DEBUG_MODE
		.data
			mstring1	db mpar1
					db 0	
		.code
		pushad
		Call	OutputDebugStringA,offset mstring1
		popad
	endif


	ifdef DEBUG_FILE
		.data
		mstring1	db mpar1
				db 0	
	.code
		pushad
		Call	Str_Len,offset mstring1
		Call	WriteFile,[file_handle_ods],offset mstring1,eax,offset bytes_written,0
		;Call	WriteFile,[file_handle_ods],offset sz_crlf1,2,offset bytes_written,0
		popad
	endif
ENDM

;------------------------------------------------------




Print_Text PROC
	ARG	@@lp_string:dword
	
	Call	Str_Len,[@@lp_string]
	dec	eax
	.IF [flag_debug_file]==0
		Call	WriteConsoleA,[std_out_handle],[@@lp_string],eax,offset nr_bytes_written,0
	.ELSE
		Call    WriteFile,[file_handle_debug],[@@lp_string],eax,offset bytes_written,0
	.ENDIF
	
	ret

ENDP


